/* 
   manaemori --- a keeper of manae
   mmprefs.c --- setting preferences
   Copyright 1998 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#include <stdio.h>
#include <System/SysAll.h>
#include <System/Graffiti.h>
#include <UI/UIAll.h>
#include <System/FeatureMgr.h>

#include "manae.h"
#include "manaemoriid.h"

static VoidPtr GetObjectPtr (Word objectID)
{
  FormPtr frm;
	
  frm = FrmGetActiveForm ();
  return (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, objectID)));

}

Boolean PreferencesApply()
{
  Byte itemNum;
  DWord mmMode;

  FtrGet(CREATOR, FEATUREMANAEMORI, &mmMode);
  itemNum = LstGetSelection (GetObjectPtr (ID_PREFS_GUI_LIST));
  FtrSet(CREATOR, FEATUREMANAEMORI, (mmMode & 0xffff0000) | (DWord)itemNum);

  return(true);
}

Boolean PreferencesInit()
{
  CharPtr label;
  ListPtr lst;
  ControlPtr ctl;
  DWord mode;
  Byte itemNum;

  lst = GetObjectPtr (ID_PREFS_GUI_LIST);
  ctl = GetObjectPtr (ID_PREFS_GUI_TRIGGER);

  if (FtrGet(CREATOR, FEATUREMANAEMORI, &mode) != 0) {
    FtrSet(CREATOR, FEATUREMANAEMORI, 0);
    mode = 0;
  }

  itemNum = (Byte)(0x000000ff & mode);

  label = LstGetSelectionText (lst, itemNum);
  CtlSetLabel (ctl, label);
  LstSetSelection (lst, itemNum);

  return(true);
}

Boolean PrefsHandleEvent(EventPtr event)
{
  Boolean handled = false;
  FormPtr frm;

  if (event->eType == ctlSelectEvent)
    {
      switch (event->data.ctlSelect.controlID)
	{
	case ID_PREFS_BUTTON_DONE:
	  PreferencesApply();
	  FrmReturnToForm (NULL);
	  handled = true;
	  break;
	  
	}
    }
  
  else if (event->eType == frmOpenEvent)
    {
      frm = FrmGetActiveForm();
      PreferencesInit();
      FrmDrawForm(frm);
      handled = true;
    }
  else if (event->eType == frmCloseEvent) {
    handled = true;
  }
  
  return (handled);
}

