/* 
   manae --- skimple kana MANA Exchanger
   myfunc.h --- 
   Copyright 1998-2000 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/
#ifndef _MYFUNC_H_
#define _MYFUNC_H_

#include <System/SysAll.h>
#include <UI/UIAll.h>

#include <UI/SonyChars.h>

CharPtr mystrncpy(CharPtr d, const Char* s, Word n);
Boolean isconsonant(Char c);
Boolean isvowel(Char c);
Int vowelNum(Char c);
Boolean space2Null(CharPtr s);
Int addChar(CharPtr str, Char c);
CharPtr MyDmStrCat(CharPtr dst, CharPtr src);
UInt MyDmGetOpenDatabaseVersion(DmOpenRef dbR);
UInt MyDmGetDatabaseVersionByTypeCreator(ULong type, ULong creator);
Err MyDmSetDatabaseVersionByTypeCreator(ULong type, ULong creator,
					UInt version);
Err MyDmDeleteDatabaseByTypeCreator(ULong type, ULong creator);
WinHandle MyDrawCharSave(CharPtr chars, Word len, SWord x, SWord y);
void MyRestore(WinHandle h, Word len, SWord x, SWord y);
Int GetGraffitiRegion(SWord screenX, SWord screenY, ULong encoding);
void ErrorPrintNum(Int i, SWord x, SWord y);
void ErrorPrintHex(ULong hex, SWord x, SWord y);


inline static UInt MyStrLen(const CharPtr s1)
{
  UInt i;

  for (i = 0; *(s1 + i) != nullChr; i++);
  return(i);
}

// 
inline static UInt LineLen(const CharPtr s1)
{
  UInt i;

  for (i = 0;
       ((*(s1 + i) != nullChr) &&
	(*(s1 + i) != linefeedChr) &&
	(*(s1 + i) != crChr));
       i++);
  return(i);
}

// 
inline static UInt MyStrCat(CharPtr s1, CharPtr s2)
{
  UInt i;

  for (i = 0; *(s1 + i) != nullChr; i++);
  for (; *s2 != nullChr; i++, s2++) {
    *(s1 + i) = *s2;
  }
  *(s1 + i) = nullChr;
  return(i);
}

inline static UInt MyStrCopyWTrm(CharPtr s1, CharPtr s2,
				 Char trm1, Char trm2, Char trm3)
{
  UInt i;
  
  for (i = 0; ((*(s2 + i) != trm1) && 
	       (*(s2 + i) != trm2) && 
	       (*(s2 + i) != trm3)); i++) {
    *(s1 + i) = *(s2 + i);
  }
  *(s1 + i) = nullChr;
  return(i);
}

inline static void ErrorPrint(CharPtr cP, SWord x, SWord y)
{
  WinDrawChars(cP, MyStrLen(cP), x, y);
}


inline static Boolean isJogUp(Word c)
{
  return(c == vchrJogUp);
}

inline static Boolean isJogDown(Word c)
{
  return(c == vchrJogDown);
}

inline static Boolean isJogPressRepeat(Word c)
{
  return(c == vchrJogPressRepeat);
}

inline static Boolean isJogPageUp(Word c)
{
  return(c == vchrJogPageUp);
}

inline static Boolean isJogPageDown(Word c)
{
  return(c == vchrJogPageDown);
}

inline static Boolean isJogPress(Word c)
{
  return(c == vchrJogPress);
}

inline static Boolean isJogRelease(Word c)
{
  return(c == vchrJogRelease);
}

// skip next sep. Even if curr char is sep, skip it.
inline static CharPtr nextSepCrLf(CharPtr s, Char sep)
{
  do {
    if ((*s == sep) ||
	(*s == linefeedChr) ||
	(*s == crChr) ||
	(*s == nullChr)) return(s);
    s++;
  } while (true);
}

// skip next cr or lf. Even if curr char is sep, skip it.
inline static CharPtr nextCrLf(CharPtr s)
{
  do {
    if ((*s == linefeedChr) ||
	(*s == crChr) ||
	(*s == nullChr)) return(s);
    s++;
  } while (true);
}

// skip next sep (only). Even if curr char is sep, skip it.
inline static CharPtr nextSep(CharPtr s, Char sep)
{
  do {
    if (*s == sep) return(s);
    s++;
  } while (true);
}


// skip next sep (only). Even if curr char is sep, skip it.
inline static Int nextSepOft(CharPtr s, Int oft, Char sep)
{
  do {
    if (*(s + oft) == sep) return(oft);
    oft++;
  } while (true);
}

#endif
